local f = CreateFrame("Frame")
local healers = {}
local dispeller = ""
local bestTime = 0
f:RegisterEvent("ENCOUNTER_START")
f:RegisterEvent("CHAT_MSG_ADDON")
RegisterAddonMessagePrefix("EnRT_DI")
f:SetScript("OnEvent", function(self, event, ...)
	if event == "ENCOUNTER_START" then
		local eID = ...
		if eID == 2048 then
			for i = 1, GetNumGroupMembers() do
				local raider = "raid"..i
				if UnitIsVisible(raider) then
					if UnitGroupRolesAssigned(raider) == "HEALER" then
						healers[#healers+1] = UnitName(raider)
					end
				end
			end
		end
	elseif event == "CHAT_MSG_ADDON" then
		local prefix, msg, channel, sender = ...
		if prefix == "EnRT_DI" then
			if tonumber(msg) then
				EnRT_DI_AssignDispell(sender, msg)
				C_Timer.After(0.5, function()
					SendAddonMessage("EnRT_DI", UnitName("player"), "WHISPER", dispeller)
				end)
			elseif UnitExists(msg) then
				print("you are the dispeller!") -- communicate to dispell
			else
				local cdStart, dur = GetSpellCooldown(msg)
				local cd = cdStart + dur
				SendAddonMessage("EnRT_DI", cd, "WHISPER", sender)
			end
		end
	end
end)
function EnRT_DI_CheckCooldowns()
	local dispell = ""
	for k, healer in pairs(healers) do
		if select(2, UnitClass(healer)) == "SHAMAN" then
			dispell = GetSpellInfo(77130) -- Purify Spirit
		elseif select(2, UnitClass(healer)) == "PALADIN" then
			dispell = GetSpellInfo(4987) -- Cleanse
		elseif select(2, UnitClass(healer)) == "DRUID" then
			dispell = GetSpellInfo(88423) -- Nature's Cure
		elseif select(2, UnitClass(healer)) == "MONK" then
			dispell = GetSpellInfo(115450) -- Detox
		elseif select(2, UnitClass(healer)) == "PRIEST" then
			dispell = GetSpellInfo(527) -- Purify
		end
		SendAddonMessage("EnRT_DI", dispell, "WHISPER", healer)
	end
end

function EnRT_DI_AssignDispell(player, time)
	if dispeller == "" then
		dispeller = player
		bestTime = time
	else
		if bestTime > time then
			dispeller = player
			bestTime = time
		end
	end
end
